import numpy as np
import matplotlib.pyplot as plt
import matplotlib.cm as cm


summation = 0
iterate = 0
Nexp = 5000
Npulls = 3000
#plt.figure(figsize=(4,9))

class Bandit:
    def __init__(self,N_arm):

        self.N_arm = N_arm
        self.lambda_ = np.ones(self.N_arm)
        self.mean_rate = 0.0
        self.arm_values = np.random.normal(0,1, self.N_arm)
        self.K = np.zeros(self.N_arm)
        self.est_values = np.ones(self.N_arm)*self.mean_rate
        self.sum_x = np.zeros(self.N_arm) # for convenience
        self.tau = np.ones(self.N_arm)
        self.sample = np.zeros(self.N_arm)

    def get_reward(self,action):
        noise = np.random.normal(0,1)
        #print(action, self.arm_values[action])
        reward = self.arm_values[action] + noise
        return reward


    #def sample(self,est_values,lambda_):
        #sreturn np.random.randn() / np.sqrt(self.lambda_) + self.est_values


    def choose_eps_greedy(self):

        self.sample = np.random.randn() / np.sqrt(self.lambda_) + self.est_values

        #print ("testprint1 is :", ucb (bandit.est_values, iterate, bandit.K))

        #print ("testprint2 is :", bandit.est_values)
        #print ("testprint2 is :", bandit.sample())
        return np.argmax(self.sample)
            #return np.argmax(self.est_values)

    def update_est(self,action, x):
        # assume tau is 1
        self.lambda_[action] += 1
        self.sum_x[action] += x
        self.est_values[action] = self.tau[action]*self.sum_x[action] / self.lambda_[action]
        return self.est_values[action]




def experiment(bandit,Npulls):

            history = []
            global summation,iterate
            iterate = iterate + 1
            for i in range(Npulls):
                action = bandit.choose_eps_greedy()
                R = bandit.get_reward(action)
                bandit.update_est(action,R)
                history.append(R)
                #print (bandit.update_est(action,R))
                """
                plt.subplot(311)
                plt.scatter(i,bandit.update_est(action,R), c= cm.spectral(action/10),alpha = 1,s =20)
                plt.pause(0.001)


                plt.subplot(312)
                #plt.scatter(Npulls*(iterate-1)+i, bandit.get_reward(action), c= set_color(action),alpha = 1,s =20)
                plt.scatter(i,  bandit.get_reward(action), c= cm.spectral(action/10),alpha = 1,s =20)


                plt.subplot(313)
                summation[i] = summation[i] + history[i]
                def set_color(l):
                    if l < 0:
                        return "r"  # red
                    else:
                        return "b"  # blue
                plt.scatter(Npulls*(iterate-1)+i, summation[i] / (1), c= set_color(summation[i]),alpha = 0.8,s =20)
                #plt.plot(summation/ (Nexp), c= 'black',alpha = 1)

                plt.pause(0.001)
                """
            return np.array(history)



"""
summation  = np.zeros(Npulls)
bayes = np.zeros(Npulls)

for i in range(Nexp):
        bandit1 = Bandit(10)
        bayes += experiment(bandit1,Npulls)
bayes /= np.float(Nexp)


plt.plot(bayes,label="Bayes-sampling")
#plt.ylim(0,2.2)

plt.legend()

plt.show()

"""
